import type { HTMLProps } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * Optional classes to add to the wrapping element.
     */
    className?: ClassName;
    /**
     * The URL for the next link.
     */
    nextURL?: string;
    /**
     * The label for the next link.
     */
    nextLabel?: string;
    /**
     * The URL for the previous link.
     */
    previousURL?: string;
    /**
     * The label for the previous link.
     */
    previousLabel?: string;
}, HTMLProps<HTMLElement>>;
declare const ArticlePagination: ({ className, nextURL, nextLabel, previousURL, previousLabel, ...props }: Props) => JSX.Element;
export default ArticlePagination;
