import { HTMLProps } from "react";
import type { ClassName, PropsWithSpread, ValueOf } from "../../types";
export declare const BadgeType: {
    readonly ROUNDED_LARGE_NUMBER: "ROUNDED_LARGE_NUMBER";
    readonly UNDEFINED_LARGE_NUMBER: "UNDEFINED_LARGE_NUMBER";
};
/**
 * The props for the Badge component.
 */
export declare type Props = PropsWithSpread<{
    /**
     * Numeric value to be displayed.
     */
    value: number;
    /**
     * The type of the badge component.
     */
    badgeType?: ValueOf<typeof BadgeType>;
    /**
     * The appearance of the badge.
     */
    isNegative?: boolean;
    /**
     * Optional class(es) to give to the badge.
     */
    className?: ClassName;
}, HTMLProps<HTMLSpanElement>>;
declare const Badge: ({ value, badgeType, className, isNegative, ...spanProps }: Props) => JSX.Element;
export default Badge;
