import type { HTMLProps, ReactNode } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The content of the card.
     */
    children?: ReactNode;
    /**
     * Optional class(es) to pass to the wrapping div element.
     */
    className?: ClassName;
    /**
     * Whether the card should have highlighted styling.
     */
    highlighted?: boolean;
    /**
     * Whether the card should have overlay styling.
     */
    overlay?: boolean;
    /**
     * The path to a thumbnail image.
     */
    thumbnail?: string;
    /**
     * The title of the card.
     */
    title?: ReactNode;
}, HTMLProps<HTMLDivElement>>;
declare const Card: ({ children, className, highlighted, overlay, thumbnail, title, ...props }: Props) => JSX.Element;
export default Card;
