import { HTMLProps } from "react";
import type { ReactNode } from "react";
import type { PropsWithSpread } from "../../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The type of the input element.
     */
    inputType: "radio" | "checkbox";
    /**
     * The label for the input element.
     */
    label: ReactNode;
    /**
     * Optional class(es) to pass to the label element.
     */
    labelClassName?: string;
    /**
     * Whether the input element should display in indeterminate state.
     */
    indeterminate?: boolean;
    /**
     * Ensures the input and the label text are properly aligned with other inline text.
     */
    inline?: boolean;
}, Omit<HTMLProps<HTMLInputElement>, "type">>;
declare const CheckableInput: ({ inputType, label, labelClassName, indeterminate, inline, ...checkboxProps }: Props) => JSX.Element;
export default CheckableInput;
