import { HTMLProps } from "react";
import type { Props as CodeSnippetBlockProps } from "./CodeSnippetBlock";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * Optional class(es) to pass to the wrapping div element.
     */
    className?: ClassName;
    /**
     * A list of code blocks to display.
     */
    blocks: CodeSnippetBlockProps[];
}, HTMLProps<HTMLDivElement>>;
export default function CodeSnippet({ className, blocks, ...props }: Props): JSX.Element;
