import type { ReactNode } from "react";
import type { Props as CodeSnippetDropdownProps } from "./CodeSnippetDropdown";
import type { ValueOf } from "../../types";
export declare const CodeSnippetBlockAppearance: {
    readonly LINUX_PROMPT: "linuxPrompt";
    readonly NUMBERED: "numbered";
    readonly URL: "url";
    readonly WINDOWS_PROMPT: "windowsPrompt";
};
export declare type Props = {
    /**
     * The appearance of the code block.
     */
    appearance?: ValueOf<typeof CodeSnippetBlockAppearance>;
    /**
     * The code snippet to display.
     */
    code: string;
    /**
     * Content to show below the code snippet.
     */
    content?: ReactNode;
    /**
     * A list of dropdowns to display in the header.
     */
    dropdowns?: CodeSnippetDropdownProps[];
    /**
     * Whether the title should display stacked on top of the dropdowns.
     */
    stacked?: boolean;
    /**
     * The title of the code block.
     */
    title?: string;
    /**
     * Whether to enable line wrapping inside the code block.
     */
    wrapLines?: boolean;
};
export default function CodeSnippetBlock({ appearance, code, content, dropdowns, stacked, title, wrapLines, }: Props): JSX.Element;
