import type { ChangeEventHandler, HTMLProps } from "react";
export declare type DropdownOptionProps = {
    /**
     * The label of the dropdown option.
     */
    label: string;
} & HTMLProps<HTMLOptionElement>;
export declare type Props = {
    /**
     * Function for handling the select value changing.
     */
    onChange: ChangeEventHandler<HTMLSelectElement>;
    /**
     * Options to pass to the select.
     */
    options: DropdownOptionProps[];
} & HTMLProps<HTMLSelectElement>;
export default function CodeSnippetDropdown({ options, onChange, ...props }: Props): JSX.Element;
