import type { LabelHTMLAttributes, ReactNode } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
/**
 * The props for the Label component.
 */
export declare type Props = PropsWithSpread<{
    /**
     * The label content.
     */
    children?: ReactNode;
    /**
     * Optional class(es) to give to the label element.
     */
    className?: ClassName;
    /**
     * The id of the input this label is connected to.
     */
    forId?: string;
    /**
     * Whether to apply required styling to the label.
     */
    required?: boolean;
}, LabelHTMLAttributes<HTMLLabelElement>>;
declare const Label: ({ children, className, forId, required, ...props }: Props) => JSX.Element;
export default Label;
