import type { HTMLProps, ReactNode } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The content of the link.
     */
    children: ReactNode;
    /**
     * Optional class(es) to pass to the wrapping anchor element.
     */
    className?: ClassName;
    /**
     * Whether the link should have inverted styling.
     */
    inverted?: boolean;
    /**
     * Whether the link should have soft styling.
     */
    soft?: boolean;
    /**
     * Whether the link should have "back to top" styling.
     */
    top?: boolean;
}, HTMLProps<HTMLAnchorElement>>;
declare const Link: ({ children, className, href, inverted, soft, top, ...props }: Props) => JSX.Element;
export default Link;
