import type { HTMLProps, ReactNode } from "react";
import type { ClassName, Headings } from "../../types";
export declare type ListItem = ReactNode | ({
    content: ReactNode;
} & HTMLProps<HTMLLIElement>);
export declare type SteppedListItem = {
    content: ReactNode;
    title: ReactNode;
    titleElement?: Headings;
} & HTMLProps<HTMLLIElement>;
export declare type Props = {
    /**
     * Optional class(es) to pass to the wrapping element.
     */
    className?: ClassName;
    /**
     * The list's items.
     */
    items: ListItem[] | SteppedListItem[];
    detailed?: boolean;
    divided?: boolean;
    inline?: boolean;
    isDark?: boolean;
    middot?: boolean;
    split?: boolean;
    stepped?: boolean;
    stretch?: boolean;
    ticked?: boolean;
} & Omit<HTMLProps<HTMLOListElement>, "type">;
declare const List: ({ className, detailed, divided, inline, isDark, items, middot, stretch, split, stepped, ticked, ...props }: Props) => JSX.Element;
export default List;
