import { ReactElement } from "react";
import type { HTMLProps, ReactNode } from "react";
import { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * Buttons to display underneath the main modal content.
     */
    buttonRow?: ReactNode | null;
    /**
     * Optional class(es) to apply to the wrapping element.
     */
    className?: ClassName;
    /**
     * The content of the modal.
     */
    children: ReactNode;
    /**
     * Function to handle closing the modal.
     */
    close?: () => void | null;
    /**
     * The title of the modal.
     */
    title?: ReactNode | null;
}, HTMLProps<HTMLDivElement>>;
export declare const Modal: ({ buttonRow, children, className, close, title, ...wrapperProps }: Props) => ReactElement;
export default Modal;
