import type { HTMLProps } from "react";
import type { PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The current page being viewed.
     */
    currentPage: number;
    /**
     * The number of items to show per page.
     */
    itemsPerPage: number;
    /**
     * Function to handle paginating the items.
     */
    paginate: (page: number) => void;
    /**
     * The total number of items.
     */
    totalItems: number;
    /**
     * Whether to scroll to the top of the list on page change.
     */
    scrollToTop?: boolean;
    /**
     * The number of pages at which to truncate the pagination items.
     */
    truncateThreshold?: number;
    /**
     * Whether or not the pagination is ceneterd on the page.
     */
    centered?: boolean;
}, HTMLProps<HTMLElement>>;
declare const Pagination: ({ itemsPerPage, totalItems, paginate, currentPage, scrollToTop, truncateThreshold, centered, ...navProps }: Props) => JSX.Element;
export default Pagination;
