import type { MouseEventHandler } from "react";
export declare enum Label {
    Next = "Next page",
    Previous = "Previous page"
}
export declare type PaginationDirection = "forward" | "back";
export declare type Props = {
    /**
     * The direction of the pagination.
     */
    direction: PaginationDirection;
    /**
     * Whether the pagination button should be disabled.
     */
    disabled?: boolean;
    /**
     * Function to handle clicking the pagination button.
     */
    onClick: MouseEventHandler<HTMLButtonElement>;
};
declare const PaginationButton: ({ direction, onClick, disabled, }: Props) => JSX.Element;
export default PaginationButton;
