import type { SearchAndFilterChip, SearchAndFilterData } from "../types";
export declare type Props = {
    /**
     * The chip data to display in the panel.
     */
    data: SearchAndFilterData;
    /**
     * The current search chips.
     */
    searchData: SearchAndFilterChip[];
    /**
     * A search string.
     */
    searchTerm: string;
    /**
     * Whether the chips should be hidden.
     */
    sectionHidden?: boolean;
    /**
     * A function to toggle whether a chip is selected.
     */
    toggleSelected: (chip: SearchAndFilterChip) => void;
};
declare const FilterPanelSection: ({ data, searchData, searchTerm, sectionHidden, toggleSelected, }: Props) => JSX.Element;
export default FilterPanelSection;
