import type { SearchAndFilterChip, SearchAndFilterData } from "./types";
export declare enum Label {
    AddFilter = "Add filter",
    Clear = "Clear input",
    SearchAndFilter = "Search and filter"
}
export declare type Props = {
    /**
     * A list of chips to initialise inside the input.
     */
    existingSearchData?: SearchAndFilterChip[];
    /**
     * The data for the filter panel.
     */
    filterPanelData: SearchAndFilterData[];
    /**
     * A function that is called when the search data changes.
     */
    returnSearchData: (searchData: SearchAndFilterChip[]) => void;
};
declare const SearchAndFilter: ({ existingSearchData, filterPanelData, returnSearchData, ...props }: Props) => JSX.Element;
export default SearchAndFilter;
