import type { ChangeEventHandler, HTMLProps, ReactNode } from "react";
import type { PropsWithSpread } from "../../types";
export declare const FILLED_COLOR = "#0066CC";
export declare const EMPTY_COLOR = "#D9D9D9";
export declare type Props = PropsWithSpread<{
    /**
     * Field caution message.
     */
    caution?: ReactNode;
    /**
     * Whether to disable the slider and input (if showInput is true).
     */
    disabled?: boolean;
    /**
     * Field error message.
     */
    error?: ReactNode;
    /**
     * Field help message.
     */
    help?: ReactNode;
    /**
     * Field id. Only passed to range input, not to number input.
     */
    id?: string;
    /**
     * Whether to disable only the input, but not the slider.
     */
    inputDisabled?: boolean;
    /**
     * Field label.
     */
    label?: ReactNode;
    /**
     * Maximum value of the slider.
     */
    max: number;
    /**
     * Minimum value of the slider.
     */
    min: number;
    /**
     * Change event handler.
     */
    onChange: ChangeEventHandler<HTMLInputElement>;
    /**
     * Whether the field is required for the form to submit.
     */
    required?: boolean;
    /**
     * Whether to show a number input with the numerical value next to the slider.
     */
    showInput?: boolean;
}, HTMLProps<HTMLInputElement>>;
export declare const Slider: ({ caution, disabled, error, help, id, inputDisabled, label, max, min, onChange, required, showInput, ...inputProps }: Props) => JSX.Element;
export default Slider;
