import { HTMLProps } from "react";
import type { ClassName } from "../../types";
export declare type Props = {
    /**
     * Optional class(es) to pass to the wrapping span element.
     */
    className?: ClassName;
    /**
     * Whether the spinner should have a light appearance.
     */
    isLight?: boolean;
    /**
     * Text to display next to the spinner.
     */
    text?: string;
    /**
     * What the role of the spinner should be.
     */
    role?: string;
    /**
     * The politeness setting of the spinner alert.
     */
    ariaLive?: "assertive" | "off" | "polite";
} & HTMLProps<HTMLSpanElement>;
declare const Spinner: ({ className, text, isLight, ariaLive, role, ...props }: Props) => JSX.Element;
export default Spinner;
