import type { HTMLProps, ReactNode } from "react";
import { ClassName, PropsWithSpread, ValueOf } from "../../types";
export declare const StatusLabelAppearance: {
    readonly CAUTION: "caution";
    readonly DEFAULT: "";
    readonly INFORMATION: "information";
    readonly NEGATIVE: "negative";
    readonly POSITIVE: "positive";
};
/**
 * The type of the StatusLabel props.
 */
export declare type Props = PropsWithSpread<{
    /**
     * The appearance of the label.
     */
    appearance?: ValueOf<typeof StatusLabelAppearance> | string;
    /**
     * The content of the label.
     */
    children?: ReactNode;
    /**
     * Optional class(es) to pass to the wrapping element.
     */
    className?: ClassName;
}, HTMLProps<HTMLDivElement>>;
/**
 * A component for the Vanilla Label.
 */
declare const StatusLabel: ({ appearance, children, className, ...labelProps }: Props) => JSX.Element;
export default StatusLabel;
