import type { ElementType, HTMLProps, ReactNode } from "react";
import type { ColSize } from "../Col/Col";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The content of the strip.
     */
    children: ReactNode;
    /**
     * A background images for the strip.
     */
    background?: string;
    /**
     * Whether the strip should display borders.
     */
    bordered?: boolean;
    /**
     * Optional classes for the strip.
     */
    className?: ClassName;
    /**
     * The width of the column if `includeCol` has been set.
     */
    colSize?: ColSize;
    /**
     * Whether the strip should be dark.
     */
    dark?: boolean;
    /**
     * Whether the strip should be deep.
     */
    deep?: boolean;
    /**
     * The base HTML element of the strip.
     */
    element?: ElementType;
    /**
     * Whether the strip should wrap the content in a column.
     */
    includeCol?: boolean;
    /**
     * Whether the strip should be light.
     */
    light?: boolean;
    /**
     * Optional classes to apply to the row.
     */
    rowClassName?: string;
    /**
     * Whether the strip should be shallow.
     */
    shallow?: boolean;
    /**
     * The type of the strip (e.g. "accent" or "image").
     */
    type?: string;
}, HTMLProps<HTMLElement>>;
declare const Strip: ({ background, bordered, children, className, colSize, dark, deep, includeCol, element: Component, light, rowClassName, shallow, type, ...props }: Props) => JSX.Element;
export default Strip;
