import type { MouseEventHandler } from "react";
import type { ClassName } from "../../types";
export declare type Props = {
    /**
     * Optional class(es) to pass to the wrapping element.
     */
    className?: ClassName;
    /**
     * Whether the summary button is loading.
     */
    isLoading?: boolean;
    /**
     * The label of the summary button.
     */
    label: string;
    /**
     * Function to handle clicking the summary button.
     */
    onClick: MouseEventHandler<HTMLButtonElement>;
    /**
     * The summary content.
     */
    summary?: string;
};
declare const SummaryButton: ({ className, isLoading, summary, label, onClick, }: Props) => JSX.Element;
export default SummaryButton;
