import { HTMLProps, ReactNode } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The content of the table.
     */
    children?: ReactNode;
    /**
     * Optional class(es) to pass to the wrapping table element.
     */
    className?: ClassName;
    /**
     * Whether the table can expand hidden cells.
     */
    expanding?: boolean;
    /**
     * Whether the table should show card styling on smaller screens.
     */
    responsive?: boolean;
}, HTMLProps<HTMLTableElement>>;
declare const Table: ({ children, className, expanding, responsive, ...props }: Props) => JSX.Element;
export default Table;
