import { HTMLProps, ReactNode } from "react";
import type { ClassName, PropsWithSpread } from "../../types";
export declare type Props = PropsWithSpread<{
    /**
     * The content of the table cell.
     */
    children?: ReactNode;
    /**
     * Optional class(es) to pass to the wrapping td element.
     */
    className?: ClassName;
    /**
     * Whether the cell is an expanded cell.
     */
    expanding?: boolean;
    /**
     * Whether content of the cell should be able to overflow, e.g. a dropdown.
     */
    hasOverflow?: boolean;
    /**
     * Whether the cell is currently hidden.
     */
    hidden?: boolean;
}, HTMLProps<HTMLTableCellElement>>;
declare const TableCell: ({ children, className, hasOverflow, expanding, hidden, role, ...props }: Props) => JSX.Element;
export default TableCell;
