export declare const THROTTLE_DELAY: number;
export declare type Callback = (...args: any[]) => any;
/**
 * A hook to handle throttling calls to a function.
 * @param callback The function to throttle.
 * @param delay The throttle delay in ms.
 * @return The callback function wrapped in the throttle.
 */
export declare const useThrottle: (callback: Callback, delay?: number) => Callback;
