import { NavLink, NavLinkAnchor, NavLinkButton } from "./components/Navigation";
export declare const IS_DEV: boolean;
/**
 * Find substring and wrap in <strong /> tag
 * @param {string} str - The string to search
 * @param {string} subString - The substring to find
 * @return {Obj} newStr - Object with text and match bool
 */
export declare const highlightSubString: (str?: string, subString?: string) => {
    text: string;
    match: boolean;
};
/**
 * Whether a navigation item is an anchor.
 * @param link - The navigation item.
 */
export declare const isNavigationAnchor: (link: NavLink) => link is NavLinkAnchor;
/**
 * Whether a navigation item is a button.
 * @param link - The navigation item.
 */
export declare const isNavigationButton: (link: NavLink) => link is NavLinkButton;
